PROGRAM Spirale;
USES
 Graph,BgiDriv,Crt;
VAR
  xc,x0,y0,m,n,x,y,v,w,b,h,gr,stp,z,s1,c1,zq:real;
  mx,my,x6,y6,x7,y7,x2,z2,x1,z1,a,c3,s3,c2,s2,s4,c4,zc,r,k,av,ce:real;
  x0l,y0l,x1l,x2l,x6l,y6l,x7l,y7l,z1l,z2l,c3l,c4l,s3l,s4l,c2l,s2l,al:real;
  code,gm,gd:integer;
  stringa:string;
  ch:char;

PROCEDURE disegna;

PROCEDURE traccia(a,b,c,d:real; colore:byte);
VAR
  x1,y1,x2,y2:real;
BEGIN
  x1:=((a/v)*mx)+mx;
  x2:=((c/v)*mx)+mx;
  y1:=my-((b/w)*my);
  y2:=my-((d/w)*my);
  setcolor(colore);
  line(trunc(x1),trunc(y1),trunc(x2),trunc(y2))
END;

PROCEDURE gosub940;
BEGIN
  zq:=-x*s1-z*c1-b;
  m:=b*y/zq;
  n:=b*(-x*c1+z*s1)/zq
END;

BEGIN {disegna}
    s1:=sin(h); c1:=cos(h);
    x:=xc+r+1; y:=0; z:=zc; gosub940;
    x6:=m; y6:=n; x6l:=m; y6l:=n;
    x:=xc-r+1; y:=0; z:=zc; gosub940;
    x7:=m; y7:=n; x7l:=m; y7l:=n;
    setgraphmode(gm);
    a:=0; al:=2*pi;
    WHILE (a<=pi) AND NOT keypressed DO
    BEGIN
      c2:=cos(a*k); s2:=sin(a*k); c2l:=cos(al*k); s2l:=sin(al*k);
      c3:=cos(a); c4:=cos(a*ce); s3:=sin(a); s4:=sin(a*av); c3l:=cos(al); c4l:=cos(a*ce); s3l:=sin(al); s4l:=sin(al*av);
      x1:=xc+r*c2+c4; z1:=zc+r*s2+s4; x1l:=xc+r*c2l+c4l; z1l:=zc+r*s2l+s4l;
      x2:=xc-r*c2+c4; z2:=zc-r*s2+s4; x2l:=xc-r*c2l+c4l; z2l:=zc-r*s2l+s4l;
      x:=x1*c3; y:=x1*s3; z:=z1; gosub940;
      x0:=m; y0:=n; traccia(m,n,x6,y6,lightblue); x6:=m; y6:=n;
      x:=x1l*c3l; y:=x1l*s3l; z:=z1l; gosub940;
      x0l:=m; y0l:=n; traccia(m,n,x6l,y6l,lightblue); x6l:=m; y6l:=n;
      x:=x2*c3; y:=x2*s3; z:=z2; gosub940;
      traccia(x0,y0,m,n,green); traccia(m,n,x7,y7,yellow); x7:=m; y7:=n;
      x:=x2l*c3l; y:=x2l*s3l; z:=z2l; gosub940;
      traccia(x0l,y0l,m,n,green); traccia(m,n,x7l,y7l,yellow); x7l:=m; y7l:=n;
      a:=a+stp; al:=al-stp
    END
END;  {disegna}


BEGIN {main}
  IF RegisterBGIDriver(@EGAVGADriverProc)<0 THEN halt;
  gd:=detect;
  initgraph(gd,gm,'');
  mx:=getmaxx/2; my:=getmaxy/2; gr:=pi/180;
  k:=50; av:=0; ce:=0; v:=5.3; w:=3; ch:='S';
  REPEAT
    randomize;
    restorecrtmode;
    IF paramcount=0 THEN
    BEGIN
      write('Demo Show ? (S/N) [N] ');
      ch:=upcase(readkey); writeln(ch);
    END;
    IF ch<>'S' THEN
    BEGIN
      write('Inserire il numero di giri [',k:4:1,'] ');
      readln(stringa); IF stringa<>'' THEN val(stringa,k,code);
      IF (trunc(k)-k)<>0 THEN
      BEGIN
        write('Lo faccio continuare fino a che non si congiunge ? (S/N) ');
        ch:=upcase(readkey); writeln(ch); IF ch='S' THEN k:=trunc(k+0.5);
      END;
      write('Inserire lo STEP di rotazione (cio la Nesima parte di un radiante) [1000] ');
      readln(stringa); IF stringa='' THEN stp:=1000 ELSE val(stringa,stp,code);
      stp:=pi/stp;
      write('Inserire l'' ANGLOLO di visualizzazione (da -75 a +75) [-20] ');
      readln(stringa); IF stringa='' THEN h:=-20 ELSE val(stringa,h,code);
      zc:=h/40;
      h:=(90+h)*gr;
      write('Inserire il RAGGIO della spirale (da 0 a 200) [80] ');
      readln(stringa); IF stringa='' THEN r:=80 ELSE val(stringa,r,code);
      r:=r/100;
      write('Inserire il DIAMETRO totale (da 0 a 500) [400] ');
      readln(stringa); IF stringa='' THEN xc:=400 ELSE val(stringa,xc,code);
      xc:=(xc/100)-1;
      write('Inserire la PROFONDITA'' della prospettiva (da 0 a 10) [5] ');
      readln(stringa); IF stringa='' THEN b:=5 ELSE val(stringa,b,code);
      b:=17-b;
      write('Inserire il numero di ONDE totali (da 0 a 10) [',av:2:0,'] ');
      readln(stringa); IF stringa<>'' THEN val(stringa,av,code);
      write('Inserire il numero di RIENTRI della spirale (da 0 a 10) [',ce:2:0,'] ');
      readln(stringa); IF stringa<>'' THEN val(stringa,ce,code);
      disegna
    END
    ELSE
    REPEAT
      k:=random(300); stp:=pi/(1+random(5500));
      h:=-44+random(90); zc:=h/45; h:=(90+h)*gr;
      r:=(2+random(9))/10; xc:=(20+random(20))/10;
      b:=8+random(10);
      IF random(9)>1 THEN av:=-8+random(15) ELSE av:=0;
      IF random(9)>1 THEN ce:=-8+random(15) ELSE ce:=av;
      disegna;
      IF NOT keypressed THEN delay(999);
    UNTIL keypressed
  UNTIL readkey=#27;
  restorecrtmode
END.